#include <avr/pgmspace.h>
#include <avrlibdefs.h>
#include <avrlibtypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include "Timer0.h"
#include <stdlib.h>

u08 str[10]={0,1,2,3,4,5,6,7,8,9};
char table[]PROGMEM = {63, 6, 91, 79, 102, 109, 125, 7, 127, 111 };
extern volatile char timer_flag ;
u08 digit = 0;
extern volatile u08 count;

void draw_digit(u08 offset){  
 PORTD |=0b01111000;
 PORTD &= ~(1 << (digit + 3));
 if((digit + offset)>= 10)
 PORTB = pgm_read_byte(&table[str[digit + offset - 10]]);
 else
 PORTB = pgm_read_byte(&table[str[digit + offset]]);
 if (++digit==4)
  digit =0;
 }


int main(void){
DDRD |=0b01111000;
DDRB = 255;
PORTD |=0b01111000;
cli();
timer0_init();
sei();
while(1){
 if(timer_flag){
   timer_flag = FALSE;
   draw_digit(count);
 }
}
};



